subroutine CONSUMPTION_SANCTION

use PARAM
use GLOBALS

implicit none

integer :: time, employment
real (long) :: local_value, local_MON_FREQ, my_rand, employment_value

do iU = 1,ngp_U
	do id = 0,max_d

		UVAL=Ugrid(iU)

        RELEVANT_element=c_MON
		send_utility=U_NO_MON(iU,id)
		call interpolate_PU(send_utility,local_value)
		consumption_high(iU,id)=local_value
		current_c_following_n(iU,id)=local_value

        send_utility=U_BAD(iU,id)
		call interpolate_PU(send_utility,local_value)
		consumption_low(iU,id)=local_value
		current_c_following_b(iU,id)=local_value
        
		consumption_sanction_level(iU,id)=consumption_high(iU,id)-consumption_low(iU,id)
		
		send_utility=U_GOOD(iU,id)
		call interpolate_PU(send_utility,local_value)
		current_c_following_g(iU,id)=local_value
		
		send_utility=U_E(iU,id)
		call interpolate_PU(send_utility,local_value)
		current_c_following_e(iU,id)=local_value

	enddo

enddo
  
if (PC_run == 1) then
    consumption_sanction_percentage = consumption_sanction_level/consumption_high

    open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\consumption_sanction.txt", position="rewind")
    write (9, *) consumption_sanction_level; close (UNIT=9)
    open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\consumption_sanction_percentage.txt", position="rewind")
    write (9, *) consumption_sanction_percentage; close (UNIT=9)
    open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\current_c_following_e.txt", position="rewind")
    write (9, *) current_c_following_e; close (UNIT=9)
    open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\current_c_following_g.txt", position="rewind")
    write (9, *) current_c_following_g; close (UNIT=9)
    open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\current_c_following_n.txt", position="rewind")
    write (9, *) current_c_following_n; close (UNIT=9)
    open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\current_c_following_b.txt", position="rewind")
    write (9, *) current_c_following_b; close (UNIT=9)

else

    open(unit=1, file="consumption_sanction.txt")
    write (1, *) consumption_sanction_level; close (UNIT=1)

endif

endsubroutine CONSUMPTION_SANCTION