subroutine FUNCTION_HN(N,X,F)

use PARAM
use GLOBALS
use UTILS

real(long), dimension (number_of_variables) :: X 
real(long), dimension (number_of_variables) :: F 
integer :: N 
real(long) :: US1,VAL_WW_U,VAL_COUPVM_U_NM, VAL_COUPVM_U_G,VAL_COUPVM_U_B, UF, U_G1, U_B1,U_NM1, consumption_argument 
real(long) :: VAL_WW, VAL_COUPVM_NM

effort = x(1)
U_NM1 = x(2)
US1 = 1/(bita*pi_a_prime(effort)) + (1-MU)*U_NM1 - MU*(((1-pi_h(id))*theta_h-(1-pi_l(id))*theta_l)*U_G1 +((1-pi_h(id))*(1-theta_h)-(1-pi_l(id))*(1-theta_l))*U_B1)/((pi_h(id)-pi_l(id))) 
consumption_argument=UVAL+e-bita*(pi_h(id)*US1+(1-pi_h(id))*((1-MU)*U_NM1 + MU*(theta_h*U_G1+(1-theta_h)*U_B1)))
call SUBVAL_WW_U(US1,VAL_WW_U)
call SUBVAL_COUPVM_U(U_G1 ,id+1,VAL_COUPVM_U_G)
call SUBVAL_COUPVM_U(U_B1 ,id+1,VAL_COUPVM_U_B)
call SUBVAL_COUPVM_U(U_NM1,id+1,VAL_COUPVM_U_NM)
call SUBVAL_WW(US,VAL_WW)
call SUBVAL_COUPVM(U_NM,id+1,VAL_COUPVM_NM)
F(1) = pi_a(effort)*VAL_WW_U + (1-pi_a(effort))*VAL_COUPVM_U_NM + UINV_PRIME(consumption_argument)
F(2) = pi_a_prime(effort)*(VAL_WW-VAL_COUPVM_NM) + (pi_a(effort)/pi_a_prime(effort)*(-UINV_PRIME(consumption_argument)-VAL_WW_U))*pi_a_double_prime(effort)*(US1-U_NM1)
if (flag_CRRA==1 .and. X(2)<0 .and. sigma<1) then
    F=10
endif

endsubroutine FUNCTION_HN