subroutine FUNCTION_MON_DNEQBF(N,X,F)

use PARAM
use GLOBALS
use UTILS

real(long), dimension (number_of_variables_NEW) :: X 
real(long), dimension (number_of_variables_NEW) :: F 
integer :: N 
real(long) :: US1,VAL_WW_U,VAL_COUPVM_U_NM, VAL_COUPVM_U_G,VAL_COUPVM_U_B, UF, U_G1, U_B1,U_NM1, consumption_argument 
real(LONG) :: obj0, obj1,obj2,  coeff_1_g, coeff_1_b, coeff_2_g, coeff_2_b, obj3, obj4

U_G1 = X(1)
U_B1 = X(2)
US1 = 1/(bita*pi_a_prime(effort))-(1-pi_a(effort))*theta_a_prime(effort,precision)*(U_G1-U_B1)/pi_a_prime(effort)+theta_a(effort,precision)*U_G1+(1-theta_a(effort,precision))*U_B1
consumption_argument=UVAL+effort-bita*(pi_a(effort)*US1+(1-pi_a(effort))*((theta_a(effort,precision)*U_G1+(1-theta_a(effort,precision))*U_B1)))
call SUBVAL_WW_U(US1,VAL_WW_U)
call SUBVAL_COUPVM_U(U_G1 ,id+1,VAL_COUPVM_U_G)
call SUBVAL_COUPVM_U(U_B1 ,id+1,VAL_COUPVM_U_B)
obj0      = UINV_PRIME(consumption_argument)
obj1      = pi_a(effort)*(1-pi_a(effort))*theta_a_prime(effort,precision)/pi_a_prime(effort)
coeff_1_g = theta_a(effort,precision)-obj1
coeff_1_b = 1-theta_a(effort,precision)+obj1
obj2      = (1-pi_a(effort))*theta_a_prime(effort,precision)/pi_a_prime(effort)
coeff_2_g = pi_a(effort)*(theta_a(effort,precision)-obj2)
coeff_2_b = pi_a(effort)*(1-theta_a(effort,precision)+obj2)
coeff_3_g = theta_a(effort,precision)*(1-pi_a(effort))
coeff_3_b = (1-theta_a(effort,precision))*(1-pi_a(effort))
obj3 = pi_a(effort)
obj4 = theta_a(effort,precision)
F(1) = obj0*coeff_1_g + coeff_2_g*VAL_WW_U + coeff_3_g*VAL_COUPVM_U_G
F(2) = obj0*coeff_1_b + coeff_2_b*VAL_WW_U + coeff_3_b*VAL_COUPVM_U_B
if (flag_CRRA==1 .and. X(2)<0 .and. sigma<1) then
    F=10
endif


endsubroutine FUNCTION_MON_DNEQBF