subroutine INTERPOLATE_PU(UU,VALUE)

use PARAM
use GLOBALS
use ULOC

implicit none
real(long),intent(in) :: UU
real(long)  :: VALUE
integer :: iU_L, iU_H
real(long) :: U_L, U_H

iU_L = IULOC_L_QUICK(UU)
iU_H = IULOC_H_QUICK(UU)
U_L = Ugrid(iU_L)
U_H = Ugrid(iU_H)
if (UU>Umax) then
	VALUE = RELEVANT_element(ngp_U,0) + (UU-Umax) / (Ugrid(ngp_U)-Ugrid(ngp_U-1))* (RELEVANT_element(ngp_U,0) - RELEVANT_element(ngp_U-1,0))
elseif (UU<Umin) then
	VALUE = RELEVANT_element(1,0) - (Umin-UU) / (Ugrid(2)-Ugrid(1))* (RELEVANT_element(2,0) - RELEVANT_element(1,0))
elseif (iU_H == iU_L)  then  
	VALUE = RELEVANT_element(iU_L,0)
elseif (iU_H == iU_L+1)  then  
    VALUE = RELEVANT_element(iU_L,0) + (RELEVANT_element(iU_H,0) - RELEVANT_element (iU_L,0)) / (U_H - U_L) * (UU - U_L)
endif

endsubroutine INTERPOLATE_PU