
PROGRAM MAIN

use NUMERICAL_LIBRARIES
use PARAM
use GLOBALS
use ULOC
use UTILS

implicit none
save

integer :: agent, time, from_experiment, to_experiment, read_previous_run, changed_ngp, changed_num_instrument_cases_to_check, use_previous_run, z0i, bypass_HN_FB, variance_switch, simulation_u_gap
real(long)  :: LOCAL_VAL_WW, local_guess, the_result, FIRST_BEST_OVER_HN, local_val, my_rand, amplitude, best_so_far, balanced_MON_FREQ, balanced_current_c_following_e, balanced_current_c_following_g, balanced_current_c_following_n, balanced_current_c_following_b, balanced_c_MON, best_so_far_effort, best_so_far_precision, threshold, previous_optimal_precision, zzz
real(long) , dimension(ngp_U) :: min_instrument_value, max_instrument_value,points_for_stdev
real(long) :: z0, best_c, best_US, best_UF, best_effort, best_theta_h, best_U_G, best_U_B, my_rand1, UF1
real(long), dimension(5) ::zz
Character(1)  xstring_1
Character(2)  xstring_2
Character(3)  xstring_3
real(long), dimension(effort_grid_size,num_instrument_cases_to_check) :: vm_608, vm_609
real(long), dimension(num_instrument_cases_to_check) :: fifty_effort, fifty_c, fifty_U_E, fifty_precision, fifty_U_G, fifty_U_B, fifty_value
integer :: iterations_before_general_utility_employment, iterations_before_general_utility_employment_MON, additional_iterations

fixed_effort=0
from_experiment = 1
to_experiment   = 1
write_simulation_data = 0
variance_switch = 1
simulate_at_balanced_budget=0
iterations_before_general_utility_employment = 100
iterations_before_general_utility_employment_MON = 100
additional_iterations = 30
bypass_HN_FB=0
simulation_u_gap=1
instrument_type = 2 
flag_CRRA = 0
use_previous_run = 1 
quick_solvers = 1
PC_run = 1            
flag_shut_down_convexification  = 0
read_previous_run= 1 
mon_cost_curvature = 1
HnN = 3                
if (use_previous_run==1) then
    first_iter_in_main_loop = num_warm_up_iterations + 1
    changed_ngp = 0 
    changed_num_instrument_cases_to_check = 0
else
    first_iter_in_main_loop = 1
    changed_ngp = 1 
    changed_num_instrument_cases_to_check = 1
endif
real_num_instrument_cases_to_check = num_instrument_cases_to_check 
call ASSIGNMENT
do agent=1,simulation_agents
	do time=1,simulation_time
		call RANDOM_NUMBER(my_rand)	
		employment_draw(agent,time)=my_rand
		call RANDOM_NUMBER(my_rand)	
		monitor_result(agent,time)=my_rand
		call RANDOM_NUMBER(my_rand)	
		monitor_choice(agent,time)=my_rand
		call RANDOM_NUMBER(my_rand)	
		unemployment_draw(time)=my_rand
	enddo
enddo
do agent=1,variance_simulation_agents 
	do time=1,variance_simulation_time
		call RANDOM_NUMBER(my_rand)	
		variance_employment_draw(agent,time)=my_rand
		call RANDOM_NUMBER(my_rand)	
		variance_monitor_result(agent,time)=my_rand
		call RANDOM_NUMBER(my_rand)	
		variance_monitor_choice(agent,time)=my_rand
		call RANDOM_NUMBER(my_rand)	
		variance_unemployment_draw(agent,time)=my_rand
	enddo
enddo
call GRIDS        
call OBJECTS
do experiment_number = from_experiment,to_experiment
    call ASSIGNMENT
    if (instrument_type == 1) then
        min_instrument_value = 0.0
    elseif (instrument_type == 2) then
        min_instrument_value = theta_l 
    endif
    max_instrument_value= 1.0 
    print *, 'EXPERIMENT ', experiment_number
    if (experiment_number<10) then
        write( xstring_1,'(i1)') [experiment_number]
        experiment='exp_00'//xstring_1
    elseif (experiment_number<100) then
        write( xstring_2,'(i2)') [experiment_number]
        experiment='exp_0'//xstring_2
    else
        write( xstring_3,'(i3)') [experiment_number]
        experiment='exp_'//xstring_3
    endif
    call EMPLOYMENT
    do iU = 2,ngp_U
        wwm_FIRST(iu)=wwm(iu)-wwm(iu-1)
    enddo
    do iU = 3,ngp_U
        wwm_second(iu)=wwm_FIRST(iu)-wwm_FIRST(iu-1)
    enddo
    do iU = 4,ngp_U
        wwm_third(iu)=wwm_second(iu)-wwm_second(iu-1)
    enddo
        wwm_third_smoothed(4)=wwm_third(4)
    do iU = 5,ngp_U
        wwm_third_smoothed(iU) = 0.90*wwm_third(iU)+0.10*wwm_third_smoothed(iU-1)
    enddo
        wwm_second_smoothed(3)=wwm_second(3)
    do iU = 4,ngp_U
        wwm_second_smoothed(iu)=wwm_second_smoothed(iu-1)+wwm_third_smoothed(iu)
    enddo
        wwm_first_smoothed(2)=wwm_first(2)
    do iU = 3,ngp_U
        wwm_first_smoothed(iu)=wwm_first_smoothed(iu-1)+wwm_second_smoothed(iu)
    enddo
        wwm_smoothed(1)=wwm(1)
    do iU = 2,ngp_U
        wwm_smoothed(iu)=wwm_smoothed(iu-1)+wwm_first_smoothed(iu)
    enddo
    open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\wwm.txt", position="rewind")
    write (9, *) wwm; close (UNIT=9)
    open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\wwm_FIRST.txt", position="rewind")
    write (9, *) wwm_FIRST; close (UNIT=9)
    open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\wwm_second.txt", position="rewind")
    write (9, *) wwm_second; close (UNIT=9)
    open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\wwm_third.txt", position="rewind")
    write (9, *) wwm_third; close (UNIT=9)
    open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\wwm_smoothed.txt", position="rewind")
    write (9, *) wwm_smoothed; close (UNIT=9)
    open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\wwm_FIRST_smoothed.txt", position="rewind")
    write (9, *) wwm_FIRST_smoothed; close (UNIT=9)
    open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\wwm_second_smoothed.txt", position="rewind")
    write (9, *) wwm_second_smoothed; close (UNIT=9)
    open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\wwm_third_smoothed.txt", position="rewind")
    write (9, *) wwm_third_smoothed; close (UNIT=9)
    call INITIAL
    call PROG_SA
    if (PC_run == 1) then
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\PARAMETERS.txt", position="rewind")
        write (9, *) PARAMETERS; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\Ugrid.txt", position="rewind")
        write (9, *) Ugrid; close (UNIT=9)
    else
        open(unit=1, file="PARAMETERS.txt")
        write (1, *) PARAMETERS; close (UNIT=1)
        open(unit=1, file="Ugrid.txt")
        write (1, *) Ugrid; close (UNIT=1)
    endif	
    if (HnN==1 .OR. HnN==3) then
        print *,'----HnN LOOP----'
        if (read_previous_run==1) then
            open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\VM_HN_HN.txt", position="rewind")
            read (9, *) VM_HN; close (UNIT=9)
            open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\VM_MON_HN.txt", position="rewind")
            read (9, *) VM_MON; close (UNIT=9)            
            open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\c_MON_HN.txt", position="rewind")
            read (9, *) c_MON; close (UNIT=9)
            open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\c_MON_WW_HN.txt", position="rewind")
            read (9, *) c_MON_WW; close (UNIT=9)
            open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_E_HN.txt", position="rewind")
            read (9, *) U_E; close (UNIT=9)
            open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_NO_MON_HN.txt", position="rewind")
            read (9, *) U_NO_MON; close (UNIT=9)
            open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_GOOD_HN.txt", position="rewind")
            read (9, *) U_GOOD; close (UNIT=9)
            open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_BAD_HN.txt", position="rewind")
            read (9, *) U_BAD; close (UNIT=9)
            open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\MON_FREQ_HN.txt", position="rewind")
            read (9, *) MON_FREQ; close (UNIT=9)
            open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\VM_MON_OLD_HN.txt", position="rewind")
            read (9, *) VM_MON_OLD; close (UNIT=9)
            open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\COUPVM_HN.txt", position="rewind")
            read (9, *) COUPVM; close (UNIT=9)
            print *, size(U_NM_instrument_guess)
            if (changed_num_instrument_cases_to_check == 0) then
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_NM_instrument_guess_HN.txt", position="rewind")
                read (9, *) U_NM_instrument_guess; close (UNIT=9)
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_G_instrument_guess_HN.txt", position="rewind")
                read (9, *) U_G_instrument_guess; close (UNIT=9)
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_B_instrument_guess_HN.txt", position="rewind")
                read (9, *) U_B_instrument_guess; close (UNIT=9)
            else
                do instrument_index = 0,num_instrument_cases_to_check				    			
                    U_NM_instrument_guess (:, instrument_index,0)=Ugrid
                    U_G_instrument_guess (:, instrument_index,0)=Ugrid
                    U_B_instrument_guess (:, instrument_index,0)=Ugrid
                enddo
            endif
            open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\amplitude_HN.txt", position="rewind")
            read (9, *) amplitude; close (UNIT=9)
                        
            open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\UPVM_HN.txt", position="rewind")
            read (9, *) UPVM; close (UNIT=9) 
        else
            vm_mon=vm_sa
            UPVM=VM_sa
            COUPVM=VM_sa
        endif  

        HnN_LOOP: do iter=first_iter_in_main_loop,maxiter    	 
            MU=0.0
            effort=0.0 
            instrument_index=0
            call DERIVATIVES      	
            do iU = 1,ngp_U
	            do id = 0,max_d

		            best_so_far = -1000000
		            UVAL=Ugrid(iU)
                    do i_effort=0,effort_grid_size
                        if (i_effort==0) then
                            effort=0.0
                        else
                            effort=effort_grid(i_effort)
                        endif
                        if (effort==0.0) then
                            VM_MON_VALUE = -exp(UVAL*(1-bita))/(1-bita)
                            US=UVAL
                            U_NM=UVAL
                            c=exp(UVAL*(1-bita))
                        else
		                    call PROG_HN
		                endif
		                if (VM_MON_VALUE>best_so_far) then
		                    best_so_far = VM_MON_VALUE
		                    VM_MON(iU,id)=VM_MON_VALUE
		                    c_MON(iU,id)=c
		                    U_E(iU,id)=US
		                    U_NO_MON(iU,id)=U_NM
		                    effort_optimal(iu,id)=effort
		                    effort_optimal_HN(iu,id)=effort
		                endif
		            enddo
	            enddo
            enddo	
            dist_plan_wwm  =  100
            do while (dist_plan_wwm>crit_plan_MON)
                wwm_old=wwm
                if (effort_grid_size==0) then
                    call employment_new
                else
                    if (iter>iterations_before_general_utility_employment) then	
                        call derivatives
                        id = 0
                        do iU = 1,ngp_U	
	                        UVAL=Ugrid(iU)        	            
                            best_so_far = -10000000000000        	            
                            do i_effort=1,effort_grid_size_emp    
                                e = effort_grid_emp(i_effort)                            
                                call PROG_EMP_GENERAL_DISUTILITY
                                if (WWM(iU)>best_so_far) then
                                    best_so_far = WWM(iU)
                                    effort_emp(iU,0)=e                            
                                endif            
                            enddo
                            WWM(iU) = best_so_far    	                
                        enddo
                    else	            
                        call employment_new
                        effort_optimal_HN_emp = effort_emp	            
                    endif
                endif
                dist_plan_wwm  =  SUM(ABS(WWM - WWM_old))/(ngp_U*ngp_d)
            end do        
            c_HN_WW=c_WW
            call CONVERGENCE    	
            if (PC_run == 1 .and. mod(iter,10)==0) then
                print *, 'HN-ITER:', iter, '    DISTANCE VALUES= ', dist_plan
            endif    	
            if (dist_plan <crit_plan_HN .and. iter>iterations_before_general_utility_employment+additional_iterations) then 
	            print *, '****CONVERGENCE REACHED****'
	            print *, 'DISTANCE = ',dist_plan
	            EXIT HnN_LOOP
            endif
            if (iter == maxiter) then 
	            print *, '****MAX NUMBER OF ITERATIONS REACHED*****'
	            print *, 'DISTANCE = ', dist_plan
	            print *, ''
	            EXIT
            endif
        enddo HnN_LOOP

        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\effort_optimal_HN.txt", position="rewind")
        write (9, *) effort_optimal; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\VM_SA.txt", position="rewind")
        write (9, *) VM_SA; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\c_SA.txt", position="rewind")
        write (9, *) c_SA; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\VM_HN.txt", position="rewind")
        write (9, *) VM_MON; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\c_HN.txt", position="rewind")
        write (9, *) c_MON; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\c_HN_WW.txt", position="rewind")
        write (9, *) c_HN_WW; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_S.txt", position="rewind")
        write (9, *) U_E; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_F.txt", position="rewind")
        write (9, *) U_NO_MON; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\VM_HN_HN.txt", position="rewind")
        write (9, *) VM_HN; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\VM_MON_HN.txt", position="rewind")
        write (9, *) VM_MON; close (UNIT=9)            
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\c_MON_HN.txt", position="rewind")
        write (9, *) c_MON; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\c_MON_WW_HN.txt", position="rewind")
        write (9, *) c_MON_WW; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_E_HN.txt", position="rewind")
        write (9, *) U_E; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_NO_MON_HN.txt", position="rewind")
        write (9, *) U_NO_MON; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_GOOD_HN.txt", position="rewind")
        write (9, *) U_GOOD; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_BAD_HN.txt", position="rewind")
        write (9, *) U_BAD; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\MON_FREQ_HN.txt", position="rewind")
        write (9, *) MON_FREQ; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\VM_MON_OLD_HN.txt", position="rewind")
        write (9, *) VM_MON_OLD; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\COUPVM_HN.txt", position="rewind")
        write (9, *) COUPVM; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_NM_instrument_guess_HN.txt", position="rewind")
        write (9, *) U_NM_instrument_guess; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_G_instrument_guess_HN.txt", position="rewind")
        write (9, *) U_G_instrument_guess; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_B_instrument_guess_HN.txt", position="rewind")
        write (9, *) U_B_instrument_guess; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\amplitude_HN.txt", position="rewind")
        write (9, *) amplitude; close (UNIT=9)               
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\UPVM_HN.txt", position="rewind")
        write (9, *) UPVM; close (UNIT=9)  
        VM_HN=VM_MON
        c_HN=c_MON
        UVAL=200
        call SUBVAL_COUPVM(UVAL,0,LOCAL_VAL_WW)
        print *, 'VM_HN_200', LOCAL_VAL_WW
        UVAL=400
        call SUBVAL_COUPVM(UVAL,0,LOCAL_VAL_WW)
        print *, 'VM_HN_400', LOCAL_VAL_WW
        print *,'----FIRST_BEST LOOP----'
        call derivatives    	
        do iU = 1,ngp_U
            do id = 0,max_d
	            UVAL=Ugrid(iU)			
                best_so_far=-1000000
                do i_effort=0,effort_grid_size
                    if (i_effort==0) then
                        effort=0.0
                    else
                        effort=effort_grid(i_effort)
                    endif
                    if (effort==0.0) then
                        VM_MON_VALUE = -exp(UVAL*(1-bita))/(1-bita)
                        US=UVAL
                        U_NM=UVAL
                        c=exp(UVAL*(1-bita))
                    else
                        c=UINV((UVAL+lifetime_discounted_effort(i_effort))*(1-bita))
                        VM_FIRST_BEST_VALUE = ((-c)*(1-bita*(1-separation))+bita*pi_a(effort)*(wage-c))/((1-bita*(1-pi_a(effort)))*(1-bita*(1-separation))-bita*pi_a(effort)*bita*separation)
                        if (separation>0) then
                            UF1=1/(bita*separation)*(UVAL*(1-bita*(1-sigma))-log(c)+e)
                        else
                            UF1=0
                        endif                
                    endif    
                    if (VM_FIRST_BEST_VALUE>best_so_far) then
                        best_so_far= VM_FIRST_BEST_VALUE
                        best_c = c
                        best_US = UVAL
                        best_UF = UF1
                        best_effort = effort
                    endif
                enddo			
                c_FB_analytic(iU,id)=best_c
	            VM_FIRST_BEST_analytic(iU,id)=best_so_far  
	            U_FB_S_analytic(iU,id) = best_US
	            U_FB_F_analytic(iU,id) = best_UF
	            effort_optimal_analytic(iu,id)=best_effort
            enddo
        enddo	
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\VM_FIRST_BEST_analytic.txt", position="rewind")
        write (9, *) VM_FIRST_BEST_analytic; close (UNIT=9)      
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\effort_optimal_FB_analytic.txt", position="rewind")
        write (9, *) effort_optimal_analytic; close (UNIT=9)      
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\c_FB_WW_analytic.txt", position="rewind")
        write (9, *) c_FB_analytic; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\c_FB_analytic.txt", position="rewind")
        write (9, *) c_FB_analytic; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_FB_S_analytic.txt", position="rewind")
        write (9, *) U_FB_S_analytic; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_FB_F_analytic.txt", position="rewind")
        write (9, *) U_FB_F_analytic; close (UNIT=9)
        dist_plan  =  100
        z0i=0
        FIRST_BEST_LOOP: do while (dist_plan>crit_plan_FB .or. z0i<iterations_before_general_utility_employment+additional_iterations) 
        COUPVM_OLD=COUPVM
        z0i=z0i+1
        call derivatives 	  
        do iU = 1,ngp_U
            do id = 0,max_d
	            UVAL=Ugrid(iU)
                best_so_far=-1000000
                do i_effort=0,effort_grid_size
                    if (i_effort==0) then
                        effort=0.0
                    else
                        effort=effort_grid(i_effort)
                    endif
                     if (effort==0.0) then
                    VM_FIRST_BEST_VALUE = -exp(UVAL*(1-bita))/(1-bita)
                    US=UVAL
                    c=exp(UVAL*(1-bita))
                    else
                        call PROG_FIRST_BEST_NEW
                    endif                
                    if (VM_FIRST_BEST_VALUE>best_so_far) then
                        best_so_far= VM_FIRST_BEST_VALUE
                        best_c = c
                        best_US = US
                        best_effort = effort
                        effort_optimal(iu,id)=effort
                    endif
                enddo			
                c_FB(iU,id)=best_c
	            VM_FIRST_BEST(iU,id)=best_so_far  
	            U_FB_S(iU,id) = best_US
            enddo
        enddo
        COUPVM=VM_FIRST_BEST
        VM_MON = VM_FIRST_BEST
        dist_plan  =  SUM(ABS(COUPVM - COUPVM_OLD))/(ngp_U*ngp_d)
        if (PC_run == 1 .and. mod(z0i,100)==0) then
            print *, 'FB-ITER:', z0i, '    DISTANCE VALUES= ', dist_plan
        endif	
        dist_plan_wwm  =  100
        wwm_old=wwm	
        if (effort_grid_size==0) then
            call employment_new
        else
            if (iter>iterations_before_general_utility_employment) then	
                call derivatives
                id = 0
                do iU = 1,ngp_U	
                    UVAL=Ugrid(iU)
                    best_so_far = -10000000000000	            
                    do i_effort=1,effort_grid_size_emp    
                        e = effort_grid_emp(i_effort)
                        call PROG_EMP_GENERAL_DISUTILITY                    
                        if (WWM(iU)>best_so_far) then
                            best_so_far = WWM(iU)
                            effort_emp(iU,0)=e                    
                        endif    
                    enddo
                    WWM(iU) = best_so_far
                enddo
            else
                call employment_new
                effort_optimal_FB_emp = effort_emp
            endif
        endif    		
        dist_plan_wwm  =  SUM(ABS(WWM - WWM_old))/(ngp_U*ngp_d)
        effort_optimal_FB=effort_optimal
        c_FB_WW=c_WW    
        COUPVM=VM_FIRST_BEST
        enddo FIRST_BEST_LOOP
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\effort_optimal_FB.txt", position="rewind")
        write (9, *) effort_optimal; close (UNIT=9)                 
        COUPVM=VM_FIRST_BEST
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\VM_FIRST_BEST.txt", position="rewind")
        write (9, *) VM_FIRST_BEST; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\c_FB_WW.txt", position="rewind")
        write (9, *) c_FB_WW; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\c_FB.txt", position="rewind")
        write (9, *) c_FB; close (UNIT=9)
        UVAL=200
        call SUBVAL_COUPVM(UVAL,0,LOCAL_VAL)
        print *, 'VM_FIRST_BEST_200', LOCAL_VAL
        UVAL=400
        call SUBVAL_COUPVM(UVAL,0,LOCAL_VAL)
        print *, 'VM_FIRST_BEST_400', LOCAL_VAL
        if (flag_CRRA == 0) then
            call IMPROVEMENT
        endif
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_0_HN.txt", position="rewind")
        write (9, *) U_0_HN; close (UNIT=9)    	    
        FIRST_BEST_OVER_HN=planner_savings
        print *, 'FIRST_BEST_OVER_HN=', FIRST_BEST_OVER_HN
        if (PC_run == 1) then
            open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\output.txt", position="rewind")
            write (9, *) output; close (UNIT=9)
        else
            open(unit=1, file="output.txt")
            write (1, *) output; close (UNIT=1)
        endif 
    endif 

    if (HnN==2 .OR. HnN==3) then
        print *, 'MONITORING LOOP'
        if (read_previous_run==1) then
            if (changed_ngp == 0) then
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\VM_HN.txt", position="rewind")
                read (9, *) VM_HN; close (UNIT=9)
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\VM_MON.txt", position="rewind")
                read (9, *) VM_MON; close (UNIT=9)            
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\c_MON.txt", position="rewind")
                read (9, *) c_MON; close (UNIT=9)
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\c_MON_WW.txt", position="rewind")
                read (9, *) c_MON_WW; close (UNIT=9)
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_E.txt", position="rewind")
                read (9, *) U_E; close (UNIT=9)
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_NO_MON.txt", position="rewind")
                read (9, *) U_NO_MON; close (UNIT=9)
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_GOOD.txt", position="rewind")
                read (9, *) U_GOOD; close (UNIT=9)
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_BAD.txt", position="rewind")
                read (9, *) U_BAD; close (UNIT=9)
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\MON_FREQ.txt", position="rewind")
                read (9, *) MON_FREQ; close (UNIT=9)
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\VM_MON_OLD.txt", position="rewind")
                read (9, *) VM_MON_OLD; close (UNIT=9)
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\COUPVM.txt", position="rewind")
                read (9, *) COUPVM; close (UNIT=9)
                if (changed_num_instrument_cases_to_check == 0) then
                    open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_NM_instrument_guess.txt", position="rewind")
                    read (9, *) U_NM_instrument_guess; close (UNIT=9)
                    open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_G_instrument_guess.txt", position="rewind")
                    read (9, *) U_G_instrument_guess; close (UNIT=9)
                    open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_B_instrument_guess.txt", position="rewind")
                    read (9, *) U_B_instrument_guess; close (UNIT=9)
                else
                    do instrument_index = 0,num_instrument_cases_to_check				    			
                        U_NM_instrument_guess (:, instrument_index,0)=Ugrid
                        U_G_instrument_guess (:, instrument_index,0)=Ugrid
                        U_B_instrument_guess (:, instrument_index,0)=Ugrid
                    enddo
                endif
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\amplitude.txt", position="rewind")
                read (9, *) amplitude; close (UNIT=9)
                            
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\UPVM.txt", position="rewind")
                read (9, *) UPVM; close (UNIT=9)    	        
            endif
        else
            amplitude=0.512 
            MON_FREQ = 0.5    
            do instrument_index = 0,num_instrument_cases_to_check				    			
            U_NM_instrument_guess (:, instrument_index,0)=Ugrid
            U_G_instrument_guess (:, instrument_index,0)=Ugrid
            U_B_instrument_guess (:, instrument_index,0)=Ugrid
            enddo    
        endif
        COUPVM = VM_MON    

        MAIN_LOOP: do iter=first_iter_in_main_loop,maxiter
            call DERIVATIVES  
            flag_exists_MU_in_range=0
            previous_optimal_precision=0.0
            do iU = 1,ngp_U
	            do id = 0,max_d
		            UVAL=Ugrid(iU)
		            best_so_far = -10000000
                    best_so_far_precision=-1000000                
                    do instrument_index = 1, num_instrument_cases_to_check 
                        precision= precision_grid(instrument_index)
                        best_so_far=-1000000                
                        do i_effort=0,effort_grid_size
                            if (i_effort==0) then
                                effort=0.0
                            else
                                effort=effort_grid(i_effort)
                            endif
		                    instrument_index_real=instrument_index
                            theta_h = -10000 
                            if (effort==0.0) then
                                VM_MON_VALUE = -exp(UVAL*(1-bita))/(1-bita)
                                US=UVAL
                                U_G=UVAL
                                U_B=UVAL
                                c=exp(UVAL*(1-bita))                    
                            else
			                    call PROG_MON_NEW
			                endif	            
	                        if (VM_MON_VALUE>best_so_far) then
		                        best_so_far= VM_MON_VALUE
		                        best_c = c
		                        best_US = US
		                        best_effort = effort
		                        if (best_effort == 0.0) then
		                            best_theta_h=0
		                        else
		                            best_theta_h = precision
		                        endif
		                        best_U_G=U_G
		                        best_U_B=U_B
		                        flag_exists_MU_in_range = 1
		                    endif
			            enddo			
			            U_E_U_theta(iU,instrument_index)=best_US
			            U_G_U_theta(iU,instrument_index)=best_U_G
			            U_B_U_theta(iU,instrument_index)=best_U_B
			            effort_U_theta(iU,instrument_index)=best_effort
			            c_U_theta(iU,instrument_index)=best_c
			            V_U_theta(iU,instrument_index)=best_so_far			
			            if (best_theta_h>previous_optimal_precision) then
			                threshold=0.0
			            else
			                threshold=0.0 
			            endif
			            if (best_so_far>best_so_far_precision+threshold) then			
		                    best_so_far_precision= best_so_far
		                    c_MON(iU,id)=best_c
	                        U_E(iU,id)=best_US	            
	                        effort_optimal(iu,id)=best_effort
	                        opt_theta_h(iU,iD) = best_theta_h
	                        U_GOOD(iU,id)=best_U_G
	                        U_BAD(iU,id)=best_U_B
	                        flag_exists_MU_in_range = 1
	                    endif			
		            enddo		
		            VM_MON_temp(iU,id)= best_so_far_precision		
		            previous_optimal_precision=opt_theta_h(iU,iD)
	            enddo
            enddo
            VM_MON = VM_MON_temp
            do iU = 1,ngp_U
                if (VM_MON(iu,0)<VM_HN(iu,0)) then
                    VM_MON(iu,0)=VM_HN(iu,0)
                endif
            enddo
            COUPVM = VM_MON
            c_MON_WW=c_WW
            dist_plan_wwm  =  100
            do while (dist_plan_wwm>crit_plan_MON)
                wwm_old=wwm	
	            if (effort_grid_size==0) then
	                call employment_new
                else
                    if (iter>iterations_before_general_utility_employment_MON) then	
                        call derivatives
                        id = 0
                        do iU = 1,ngp_U	
                            UVAL=Ugrid(iU)
                            best_so_far = -10000000000000	            
                            do i_effort=1,effort_grid_size_emp    
                                e = effort_grid_emp(i_effort)
                                call PROG_EMP_GENERAL_DISUTILITY
                                if (WWM(iU)>best_so_far) then
                                    best_so_far = WWM(iU)
                                    effort_emp(iU,0)=e                    
                                endif    
                            enddo
                            WWM(iU) = best_so_far
                        enddo
                    else
                        call employment_new
                        effort_optimal_emp = effort_emp
                    endif
                endif    	
	            dist_plan_wwm  =  SUM(ABS(WWM - WWM_old))/(ngp_U*ngp_d)
            end do	
            c_MON_WW=c_WW
            call CONVERGENCE
            if (PC_run == 1 .and. mod(iter,10)==0) then
                print *, 'MON-ITER:', iter, '    DISTANCE VALUES= ', dist_plan
            endif
            if (PC_run == 1 .and. mod(iter,150)==0) then
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_E_U_theta.txt", position="rewind")
                write (9, *) U_E_U_theta; close (UNIT=9)    
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_G_U_theta.txt", position="rewind")
                write (9, *) U_G_U_theta; close (UNIT=9)    
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_B_U_theta.txt", position="rewind")
                write (9, *) U_B_U_theta; close (UNIT=9)    
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\effort_U_theta.txt", position="rewind")
                write (9, *) effort_U_theta; close (UNIT=9)    
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\c_U_theta.txt", position="rewind")
                write (9, *) c_U_theta; close (UNIT=9)    
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\V_U_theta.txt", position="rewind")
                write (9, *) V_U_theta; close (UNIT=9)    
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\amplitude.txt", position="rewind")
                write (9, *) amplitude; close (UNIT=9)    
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\VM_MON.txt", position="rewind")	
                write (9, *) VM_MON; close (UNIT=9)	
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\VM_MON_OLD.txt", position="rewind")	
                write (9, *) VM_MON_old; close (UNIT=9)
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\VM_HN.txt", position="rewind")
                write (9, *) VM_HN; close (UNIT=9)
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\c_MON.txt", position="rewind")
                write (9, *) c_MON; close (UNIT=9)
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\c_MON_WW.txt", position="rewind")
                write (9, *) c_MON_WW; close (UNIT=9)
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_E.txt", position="rewind")
                write (9, *) U_E; close (UNIT=9)	
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_NO_MON.txt", position="rewind")
                write (9, *) U_NO_MON; close (UNIT=9)
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_GOOD.txt", position="rewind")
                write (9, *) U_GOOD; close (UNIT=9)
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_BAD.txt", position="rewind")
                write (9, *) U_BAD; close (UNIT=9)		
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\MON_FREQ.txt", position="rewind")
                write (9, *) MON_FREQ; close (UNIT=9)    
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\opt_theta_h.txt", position="rewind")
                write (9, *) opt_theta_h; close (UNIT=9)
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\COUPVM.txt", position="rewind")
                write (9, *) COUPVM; close (UNIT=9)    
                 open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\UPVM.txt", position="rewind")
                write (9, *) UPVM; close (UNIT=9)
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_NM_instrument_guess.txt", position="rewind")
                write (9, *) U_NM_instrument_guess; close (UNIT=9)
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_G_instrument_guess.txt", position="rewind")
                write (9, *) U_G_instrument_guess; close (UNIT=9)
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_B_instrument_guess.txt", position="rewind")
                write (9, *) U_B_instrument_guess; close (UNIT=9)    
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\effort_optimal_MON.txt", position="rewind")
                write (9, *) effort_optimal; close (UNIT=9)      
                if (flag_CRRA == 0) then
                    call IMPROVEMENT
                endif
            endif
            if (dist_plan <crit_plan_MON .and. iter>iterations_before_general_utility_employment_MON+additional_iterations) then 
                print *, '****CONVERGENCE REACHED'
                print *, 'DISTANCE = ',dist_plan	
                if (iter>num_warm_up_iterations) then 
	                EXIT MAIN_LOOP 
                endif    		
            endif
            if (iter == maxiter) then     	
                print *, '****MAX NUMBER OF ITERATIONS REACHED*****'
                print *, 'DISTANCE = ', dist_plan
                print *, ''
                stop
            endif
            if (PC_run == 1) then
                open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\output.txt", position="rewind")
                write (9, *) output; close (UNIT=9)
            else
                open(unit=1, file="output.txt")
                write (1, *) output; close (UNIT=1)
            endif
        enddo MAIN_LOOP
        variance_index=1
        do U_index=1,ngp_U,simulation_u_gap
            call SIM_BEFORE_RUN
            points_for_stdev(variance_index) = Ugrid(U_index)
            variance_index=variance_index+1
        enddo
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\stdev_c_HN.txt", position="rewind")
        write (9, *) stdev_c_HN; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\stdev_c_MON.txt", position="rewind")
        write (9, *) stdev_c_MON; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\stdev_c_FB.txt", position="rewind")
        write (9, *) stdev_c_FB; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\mean_c_HN.txt", position="rewind")
        write (9, *) mean_c_HN; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\mean_c_MON.txt", position="rewind")
        write (9, *) mean_c_MON; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\mean_c_FB.txt", position="rewind")
        write (9, *) mean_c_FB; close (UNIT=9)
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\points_for_stdev.txt", position="rewind")
        write (9, *) points_for_stdev; close (UNIT=9)
        print *, 'MAIN LOOP completed'
        if (flag_CRRA == 0) then
            call IMPROVEMENT
        endif
        percent_savings=planner_savings/FIRST_BEST_OVER_HN
        print *, 'SIMULATING MON HN'
        call consumption_sanction
        RELEVANT_element=MON_FREQ
        call interpolate_PU(U_0_HN,balanced_MON_FREQ)
        RELEVANT_element=current_c_following_e
        call interpolate_PU(U_0_HN,balanced_current_c_following_e)
        RELEVANT_element=current_c_following_g
        call interpolate_PU(U_0_HN,balanced_current_c_following_g)
        RELEVANT_element=current_c_following_n
        call interpolate_PU(U_0_HN,balanced_current_c_following_n)
        RELEVANT_element=current_c_following_b
        call interpolate_PU(U_0_HN,balanced_current_c_following_b)
        RELEVANT_element=c_MON
        call interpolate_PU(U_0_HN,balanced_c_MON)
        output(1) = experiment_number
        output(2)= ngp_U
        output(3) =FIRST_BEST_OVER_HN
        output(4) =planner_savings
        output(5) =percent_savings
        output(6) =consumption_increase
        output(7)=U_0_HN
        output(8)=balanced_MON_FREQ
        output(9)=balanced_c_MON
        output(10)=(balanced_current_c_following_e-balanced_current_c_following_n)/balanced_current_c_following_n
        output(11)=(balanced_current_c_following_g-balanced_current_c_following_n)/balanced_current_c_following_n
        output(12)=(balanced_current_c_following_b-balanced_current_c_following_n)/balanced_current_c_following_n
        output(17)= UMIN
        output(18)= UMAX
        output(19)= simulation_time
        output(20)= simulation_agents
        if (PC_run == 1) then
            open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\output.txt", position="rewind")
            write (9, *) output; close (UNIT=9)
        else
            open(unit=1, file="output.txt")
            write (1, *) output; close (UNIT=1)
        endif        
    endif 
enddo

open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\amplitude.txt", position="rewind")
write (9, *) amplitude; close (UNIT=9)
open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\VM_MON.txt", position="rewind")	
write (9, *) VM_MON; close (UNIT=9)
open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\VM_MON_OLD.txt", position="rewind")	
write (9, *) VM_MON_old; close (UNIT=9)
open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\VM_HN.txt", position="rewind")
write (9, *) VM_HN; close (UNIT=9)
open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\c_MON.txt", position="rewind")
write (9, *) c_MON; close (UNIT=9)
open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\c_MON_WW.txt", position="rewind")
write (9, *) c_MON_WW; close (UNIT=9)
open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_E.txt", position="rewind")
write (9, *) U_E; close (UNIT=9)
open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_NO_MON.txt", position="rewind")
write (9, *) U_NO_MON; close (UNIT=9)
open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_GOOD.txt", position="rewind")
write (9, *) U_GOOD; close (UNIT=9)
open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_BAD.txt", position="rewind")
write (9, *) U_BAD; close (UNIT=9)
open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\MON_FREQ.txt", position="rewind")
write (9, *) MON_FREQ; close (UNIT=9)
open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\opt_theta_h.txt", position="rewind")
write (9, *) opt_theta_h; close (UNIT=9)
open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\COUPVM.txt", position="rewind")
write (9, *) COUPVM; close (UNIT=9)
open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\UPVM.txt", position="rewind")
write (9, *) UPVM; close (UNIT=9)
open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_NM_instrument_guess.txt", position="rewind")
write (9, *) U_NM_instrument_guess; close (UNIT=9)
open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_G_instrument_guess.txt", position="rewind")
write (9, *) U_G_instrument_guess; close (UNIT=9)
open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\U_B_instrument_guess.txt", position="rewind")
write (9, *) U_B_instrument_guess; close (UNIT=9)
open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\effort_optimal_MON.txt", position="rewind")
write (9, *) effort_optimal; close (UNIT=9)  

print *, 'program completed'

endprogram MAIN





