module PARAM


implicit none
save

integer, parameter:: LONG = SELECTED_REAL_KIND (15,8) 
integer, parameter :: num_warm_up_iterations = 50
real(long) , parameter  :: extra_grid_points = 0
real(long) , parameter  :: SCALER = 0.01
real(long) , parameter  :: theta_h_parameter = 0.95
real(long), parameter :: cmingrid = SCALER*20
real(long), parameter :: wmax = 30
real(long) , parameter  :: wage = SCALER*38 
real(long) , parameter :: bita = 0.997539798 
integer, parameter :: ngp_U = 200 
real(long) , parameter  :: UMIN	= -650 
real(long) , parameter  :: UMAX = -200 
integer, parameter :: IND_CHEBISHEV = 0			
integer, parameter :: CHEBORD = 20				
integer, parameter :: max_d = 0				
integer, parameter :: ngp_d = max_d+1			
integer, parameter :: ngp_Ugraph = 800			
integer, parameter :: ngp_dgraph = ngp_d		
real(long) , parameter :: p_e=0 				
real(long) , parameter :: p_u=0 				
real(long) , parameter:: actual_MON_FREQ = 0.20
real(long) , parameter :: crit_plan_HN =  0.00005 
real(long) , parameter :: crit_plan_FB =  0.00005 
real(long) , parameter :: crit_plan_MON = 0.00005 
integer, parameter ::  maxiter = 1000000
real(long) , parameter :: ERRREL =  0.00000000001 
integer, parameter :: itmax = 2000
real(long) :: tiny =0.00
integer, parameter:: iseed = 9821					
integer, parameter:: SIM = 10000					
integer, parameter:: TT = 50						
integer, parameter:: OPT_SIM = 84					
integer, parameter:: OPT_TT = 50					
integer, parameter :: t_bar = 13					
character (7) :: parg = 'eff050l' 
integer, parameter :: number_of_variables = 3  
integer, parameter :: number_of_variables_NEW = 2  
integer, parameter :: number_of_variables_HN = 1  
integer, parameter :: iter_for_subtle_sub_val = 25
integer, parameter :: num_of_periods = 20
integer, parameter :: paths_employment_time = 10
integer, parameter :: c_simulation_time = 10000
integer, parameter :: simulation_time = 1500 
integer, parameter :: tailored_simulation_time = 12 
integer, parameter :: simulation_agents = 500
integer, parameter :: variance_simulation_agents = 1000
integer, parameter :: variance_simulation_time = 60 
real (long), parameter :: effort_coefficient = 5.1 
integer, parameter :: effort_grid_size = 20 
real (long), parameter :: max_effort_grid = 1.51 
real (long), parameter :: min_effort_grid = 0.025 
integer, parameter :: effort_grid_size_emp = 2
real (long), parameter :: max_effort_grid_emp = 0.49 
real (long), parameter :: min_effort_grid_emp = 0.49 
real (long), parameter :: max_effort = 1.51 
real (long), parameter :: min_effort = 0.025
real (long), parameter :: pi_curvature = 1.4 
real (long), parameter :: max_pi_possible = 1.0 
real (long), parameter :: delta_parameter = 0.5 
real (long), parameter :: precision_cost = 5*scaler/100 
real (long), parameter :: max_precision = 1.00
real (long), parameter :: separation = 0.02 
real (long), parameter :: efficiency_factor_signal_slope =  0.5*7.0
real (long), parameter :: theta_a_parameter = 0.6
real (long), parameter :: factor_effectivness_theta = 1.0
real (long), parameter :: precision_curvature = 2.0
integer, parameter :: num_instrument_cases_to_check = 20 
integer, parameter :: max_instrument_index = num_instrument_cases_to_check+extra_grid_points
integer, parameter :: precision_grid_size = num_instrument_cases_to_check 
real(long) , parameter :: etha=1.000-separation

endmodule PARAM
