subroutine PROG_EMP_GENERAL_DISUTILITY

use PARAM
use GLOBALS
use UTILS
use NUMERICAL_LIBRARIES

implicit none
external FUNCTION_EMP_GENERAL_DISUTILITY_DZBREN
real(long) :: VAL_WW,   VAL_COUPVM_G,   VAL_COUPVM_B,   VAL_COUPVM_NM, A, B
real(long) :: VAL_WW_U, VAL_COUPVM_U_G, VAL_COUPVM_U_B, VAL_COUPVM_U_NM, FUNCTION_EMP_GENERAL_DISUTILITY_DZBREN
real(long) :: consumption_argument, FNORM 
real(long) ::  sum_U_G_UVAL_gap,  sum_U_B_UVAL_gap,  sum_U_NM_UVAL_gap
real(long) :: mean_U_G_UVAL_gap, mean_U_B_UVAL_gap, mean_U_NM_UVAL_gap
integer :: sum_index_U_G_UVAL_gap, sum_index_U_B_UVAL_gap, sum_index_U_NM_UVAL_gap, iU_index
real(long) :: a1,a2,a3,a4,a5,a6,a7
real(long) :: X1
integer, parameter :: N=number_of_variables_HN
real(long), dimension(number_of_variables_HN) :: FSCALE, FVECT, XSCALE, EST_V_MON_FOC 
integer, dimension(6) :: IPARAM
real(long), dimension(5) :: RPARAM
real(long), dimension(18) :: DEBUG
real(long)  :: ERRABS 
real (LONG) :: ERREL 
real(long)  :: EPS 
real (LONG) :: ETA , tolerance, tolerance_threshold, U_NM1, US1 
integer :: NROOT 
integer :: INFO

ERRABS = 0.00000000001
ERREL =  0.00000000001
EPS = 1.0 
ETA = 1.0
NROOT = 1
MAXFIN = 10000
XSCALE(1)=1
FSCALE(1)=0.1 
IPARAM(3)=1000000
IPARAM(4)=40000
call ERSET (1,0,-1)
call ERSET (2,0,-1)
call ERSET (3,0,-1)
A=uval-25 
B=uval+25 
MAXFIN = 10000
round_id=0
call DZBREN (FUNCTION_EMP_GENERAL_DISUTILITY_DZBREN, ERRABS, ERREL, A, B, MAXFIN)
tolerance =1
tolerance_threshold = 0.00001
U_NM1 = B
consumption_argument=UVAL+e-bita*((1-separation)*UVAL+separation*U_NM1)
call SUBVAL_WW(UVAL,VAL_WW)
call SUBVAL_COUPVM(U_NM1 ,id+1,VAL_COUPVM_NM)
c=UINV(consumption_argument)
WWM(iU)  =  wage -c + bita*(1-separation)*VAL_WW+bita*separation*VAL_COUPVM_NM
c_WW(iU,0)=c

endsubroutine PROG_EMP_GENERAL_DISUTILITY