subroutine PROG_HN

use PARAM
use GLOBALS
use UTILS
use NUMERICAL_LIBRARIES

implicit none
external FUNCTION_HN, FUNCTION_HN_DNEQNF, FUNCTION_HN_DZBREN
real(long) :: VAL_WW,   VAL_COUPVM_G,   VAL_COUPVM_B,   VAL_COUPVM_NM, A, B
real(long) :: VAL_WW_U, VAL_COUPVM_U_G, VAL_COUPVM_U_B, VAL_COUPVM_U_NM, FUNCTION_HN_DZBREN
real(long) :: consumption_argument, FNORM 
real(long) ::  sum_U_G_UVAL_gap,  sum_U_B_UVAL_gap,  sum_U_NM_UVAL_gap
real(long) :: mean_U_G_UVAL_gap, mean_U_B_UVAL_gap, mean_U_NM_UVAL_gap
integer :: sum_index_U_G_UVAL_gap, sum_index_U_B_UVAL_gap, sum_index_U_NM_UVAL_gap, iU_index
real(long) :: a1,a2,a3,a4,a5,a6,a7
real(long) :: X1, XGUESS1
integer, parameter :: N=number_of_variables_HN
real(long), dimension(number_of_variables_HN) :: FSCALE, FVECT, XSCALE, EST_V_MON_FOC 
integer, dimension(6) :: IPARAM
real(long), dimension(5) :: RPARAM
real(long), dimension(18) :: DEBUG
real(long)  :: ERRABS 
real (LONG) :: ERREL 
real(long)  :: EPS 
real (LONG) :: ETA , tolerance, tolerance_threshold, U_NM1, US1 
integer :: NROOT 
integer :: INFO
real(long)::FUNCTION_HN_DZBREN_middle,FUNCTION_HN_DZBREN_a,FUNCTION_HN_DZBREN_b

ERRABS = 0.00000000001
ERREL =  0.00000000001
EPS = 1.0 
ETA = 1.0
NROOT = 1
MAXFIN = 10000
XSCALE(1)=1
FSCALE(1)=0.1 
IPARAM(3)=1000000
IPARAM(4)=40000
call ERSET (1,0,-1)
call ERSET (2,0,-1)
call ERSET (3,0,-1)
A=uval-8
B=uval+8
MAXFIN = 10000
XGUESS1 = UVAL - 1
call DZBREN (FUNCTION_HN_DZBREN, ERRABS, ERREL, A, B, MAXFIN)
tolerance =1
tolerance_threshold = 0.00001
U_NM = B
US = U_NM+1/(bita*pi_a_prime(effort))
consumption_argument=UVAL+effort-bita*(pi_a(effort)*US+(1-pi_a(effort))*U_NM)
call SUBVAL_WW_U(US,VAL_WW_U)
call SUBVAL_COUPVM_U(U_G ,id+1,VAL_COUPVM_U_G)
call SUBVAL_COUPVM_U(U_B ,id+1,VAL_COUPVM_U_B)
call SUBVAL_COUPVM_U(U_NM,id+1,VAL_COUPVM_U_NM)
call SUBVAL_WW(US,VAL_WW)
call SUBVAL_COUPVM(U_G ,id+1,VAL_COUPVM_G)
call SUBVAL_COUPVM(U_B ,id+1,VAL_COUPVM_B)
call SUBVAL_COUPVM(U_NM,id+1,VAL_COUPVM_NM)
c=UINV(consumption_argument)
if (flag_CRRA==1 .and. isnan(c)) then
    c=0.01
endif
VM_MON_VALUE= -c + bita*pi_a(effort)*VAL_WW+bita*(1.-pi_a(effort))*VAL_COUPVM_NM 
if (iter>=num_warm_up_iterations) then 
    U_NM_instrument_guess(iU,instrument_index,id)=U_NM
    U_G_instrument_guess (iU,instrument_index,id)=U_G
    U_B_instrument_guess (iU,instrument_index,id)=U_B
endif

endsubroutine PROG_HN