subroutine SUBVAL_COUPVM(UU,id1,VAL_COUPVM)

use PARAM
use GLOBALS
use ULOC

implicit none
real(long),intent(in) :: UU
integer, intent (in) :: id1
real(long)  :: VAL_COUPVM
integer :: iU_L, iU_H, id2
real(long) :: U_L, U_H
if (id1<=max_d) then
	id2=id1
else
	id2=id1-1
endif
iU_L = IULOC_L_QUICK(UU)
iU_H = IULOC_H_QUICK(UU)
U_L = Ugrid(iU_L)
U_H = Ugrid(iU_H)
if (UU>Umax) then	
	if (COUPVM(ngp_U-1,id2) - COUPVM(ngp_U-2,id2) /=0 .and. iter>iter_for_subtle_sub_val) then  
		VAL_COUPVM = COUPVM(ngp_U,id2) + (UU-Umax) / (Ugrid(ngp_U)-Ugrid(ngp_U-1))* (COUPVM(ngp_U,id2) - COUPVM(ngp_U-1,id2))/ (Ugrid(ngp_U)-Ugrid(ngp_U-1))* (COUPVM(ngp_U,id2) - COUPVM(ngp_U-1,id2))* (Ugrid(ngp_U-1)-Ugrid(ngp_U-2))/ (COUPVM(ngp_U-1,id2) - COUPVM(ngp_U-2,id2))
	else
		VAL_COUPVM = COUPVM(ngp_U,id2) + (UU-Umax) / (Ugrid(ngp_U)-Ugrid(ngp_U-1))* (COUPVM(ngp_U,id2) - COUPVM(ngp_U-1,id2))
	endif
elseif (UU<Umin) then
	if (COUPVM(3,id2) - COUPVM(2,id2) /= 0 .and. iter>iter_for_subtle_sub_val) then	
		VAL_COUPVM = COUPVM(1,id2) - (Umin-UU) / (Ugrid(2)-Ugrid(1))* (COUPVM(2,id2) - COUPVM(1,id2))/ (Ugrid(2)-Ugrid(1))* (COUPVM(2,id2) - COUPVM(1,id2)) * (Ugrid(3)-Ugrid(2)) / (COUPVM(3,id2) - COUPVM(2,id2)) 	
	else
		VAL_COUPVM = COUPVM(1,id2) - (Umin-UU) / (Ugrid(2)-Ugrid(1))* (COUPVM(2,id2) - COUPVM(1,id2)) 	
	endif	
elseif (iU_H == iU_L)  then  
	VAL_COUPVM = COUPVM(iU_L,id2)
elseif (iU_H == iU_L+1)  then  
	VAL_COUPVM = COUPVM(iU_L,id2) + (COUPVM(iU_H,id2) - COUPVM(iU_L,id2)) / (U_H - U_L)  & 
	                  * (UU - U_L)
else
    stop	
endif

endsubroutine SUBVAL_COUPVM