subroutine TAILORED_CONSUMPTION_SIMULATION_HN

use PARAM
use GLOBALS

implicit none
integer :: agent, time
real (long) :: local_value, local_MON_FREQ

PU(1)=-580 
agent_state(0)=0
do agent=1,3
    agent_state=2
    do time=1,tailored_simulation_time-1
	    if (time>4) then    		
			agent_state(time)=1
	    endif
	    RELEVANT_element=c_HN
	    send_value=PU(time)
	    call interpolate_PU(send_value,local_value)
	    consumption(time)=local_value
	    if (agent_state(time-1)==1) then     		
		    PU(time+1)=PU(time)    		
	    else 		
		    if (agent_state(time)==1) then     			
			    RELEVANT_element=U_S
			    send_value=PU(time)
			    call interpolate_PU(send_value,local_value)
			    PU(time+1)=local_value
		    elseif (agent_state(time)==2) then     			
			    RELEVANT_element=U_F
			    send_value=PU(time)
			    call interpolate_PU(send_value,local_value)
			    PU(time+1)=local_value			 
		    else
			    print *, 'MISSING AGENT STATE'
		    endif 
	    endif 
    enddo 
    if (agent_state(time)>1) then
	    RELEVANT_element=c_HN
	    send_value=PU(time)
	    call interpolate_PU(send_value,local_value)
	    consumption(time)=local_value
    elseif (agent_state(time)==1) then
	    RELEVANT_element=c_HN_WW
	    send_value=PU(time)
	    call interpolate_PU(send_value,local_value)
	    consumption(time)=local_value		
    endif
	if (PC_run == 1) then
	    if (agent==1) then
	        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\tailored_simulated_consumption_HN1.txt", position="rewind")
	        write (9, *) consumption; close (UNIT=9)
	    elseif (agent==2) then
	        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\tailored_simulated_consumption_HN2.txt", position="rewind")
	        write (9, *) consumption; close (UNIT=9)
	    elseif (agent==3) then
	        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\tailored_simulated_consumption_HN3.txt", position="rewind")
	        write (9, *) consumption; close (UNIT=9)
	    endif  
    else
        if (agent==1) then
	        open(unit=1, file="tailored_simulated_consumption_HN1.txt")
	        write (1, *) consumption; close (UNIT=1)
	    elseif (agent==2) then
	        open(unit=1, file="tailored_simulated_consumption_HN2.txt")
	        write (1, *) consumption; close (UNIT=1)
	    elseif (agent==3) then
	        open(unit=1, file="tailored_simulated_consumption_HN3.txt")
	        write (1, *) consumption; close (UNIT=1)
	    endif   	
	endif	
enddo

endsubroutine TAILORED_CONSUMPTION_SIMULATION_HN