module ULOC

use PARAM
use GLOBALS

implicit none
CONTAINS

function IULOC_L_QUICK(UU) 
real (long), intent(in) :: UU
real (long) :: x,y
integer::x1
integer :: IULOC_L_QUICK, iUlow

y=ngp_U
x=(UU-Umin)/((Umax-Umin)/(ngp_U-1)) 
x1=x
iUlow=x1+1
if (iUlow>ngp_U) then
    iUlow=ngp_U
elseif (iUlow<1) then
    iUlow=1
endif
IULOC_L_QUICK=floor(x)+1
IULOC_L_QUICK=max(IULOC_L_QUICK,1)
IULOC_L_QUICK=min(IULOC_L_QUICK,ngp_U)
if (UU == Ugrid(iUlow)) then
    IULOC_L_QUICK=iUlow
endif
if (iUlow<ngp_U ) then
    if (UU == Ugrid(iUlow+1)) then
        IULOC_L_QUICK=iUlow+1
    endif
endif
endfunction IULOC_L_QUICK

function IULOC_H_QUICK(UU) 
real (long), intent(in) :: UU
real :: x 
integer::x1
integer :: IULOC_H_QUICK, iUhigh

x=(UU-Umin)/((Umax-Umin)/(ngp_U-1))
x1=x
if (iUhigh>ngp_U) then
    iUhigh=ngp_U
elseif (iUhigh<1) then
    iUhigh=1
endif
if (UU == Ugrid(iUhigh)) then
    IULOC_H_QUICK=iUhigh
else
    IULOC_H_QUICK=ceiling(x)+1
    IULOC_H_QUICK=max(IULOC_H_QUICK,1)
    IULOC_H_QUICK=min(IULOC_H_QUICK,ngp_U)
endif
endfunction IULOC_H_QUICK

function IULOC_L(UU) 
real(long) , intent(in) :: UU
integer :: IULOC_L, iUlow

if ( UU <= Ugrid(1) ) then 
	IULOC_L = 1
elseif (UU >= Ugrid(ngp_U)) then 
	IULOC_L = ngp_U
else
	do iUlow = 1, ngp_U-1
		if ( UU >= Ugrid(iUlow)  .AND. (UU < Ugrid(iUlow+1)) ) then
			IULOC_L = iUlow
		endif
	enddo
endif
endfunction IULOC_L

function IULOC_H(UU)
real(long) , intent(in) :: UU
integer :: IULOC_H, iUlow

if ( UU <= Ugrid(1) ) then 
	IULOC_H = 1
elseif (UU >= Ugrid(ngp_U)) then 
	IULOC_H = ngp_U
else
	do iUlow = 1, ngp_U-1
		if ( UU > Ugrid(iUlow)  .AND. (UU < Ugrid(iUlow+1)) ) then
			IULOC_H = iUlow+1
		elseif ( UU == Ugrid(iUlow)  ) then
			IULOC_H = iUlow
		endif
	enddo
endif
endfunction IULOC_H

endmodule ULOC