subroutine CONVERGENCE

use PARAM
use GLOBALS

implicit none
save

external UPPENV, CONVEXIFY


integer :: id1, iU1
real(long)  :: UU, UPV, COUPV

do id1=0, max_d
	do iU1=1, ngp_U
	
		UU=Ugrid(iU1)

		call UPPENV(UU, id1, UPV)
		UPVM(iU1,id1) = VM_MON(iU1, id1) 
		if (flag_shut_down_convexification == 0) then
		call CONVEXIFY(UU, id1, COUPV)
		COUPVM(iU1,id1) = COUPV 
		endif
		
	enddo
enddo

if (flag_shut_down_convexification == 1) then
    coupvm=upvm
endif

dist_plan  =  SUM(ABS(VM_MON - VM_MON_old))/(ngp_U*ngp_d)
dist_plan_MON = SUM(ABS(VM_MON - VM_MON_old))/(ngp_U*ngp_d)

if (HnN==0) then
    if (PC_run == 1) then
        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\VM_MON_OLD.txt", position="rewind")
        write (9, *) VM_MON_OLD; close (UNIT=9)
    
    else
    
    open(unit=1, file="VM_MON_OLD.txt")
    write (1, *) VM_MON_OLD; close (UNIT=1)
    
    endif
endif

VM_SA_old = VM_SA
VM_MON_old=VM_MON
COUPVM_old=COUPVM

endsubroutine CONVERGENCE