subroutine CONVEXIFY(UU, id2, COUPV)

use PARAM
use GLOBALS
use NUMERICAL_LIBRARIES
use ULOC

implicit none

 
real(long) ,intent (in) :: UU
integer, intent(in) :: id2
real(long) ,intent (out) :: COUPV


integer, parameter :: M = 2
integer, parameter:: NVAR = ngp_U
integer, parameter:: LDA = M

real(long), dimension (M,NVAR) :: A
real(long), dimension (M) :: BL, BU, DSOL
real(long), dimension (NVAR) :: C1
integer, dimension(M) :: IRTYPE
real(long), dimension (NVAR) :: XLB, XUB, XSOL
real(long)  :: OBJ

A(1,1:NVAR) = 1.0
A(2,1:NVAR) = Ugrid
BL(1) = 1.0
BL(M) = UU
BU(1) = 1.0
BU(M) = UU
C1 = -UPVM(1:ngp_U, id2)
IRTYPE = 0
XLB = 0.0
XUB = 1.0

call DDLPRS (M, NVAR, A, LDA, BL, BU, C1, IRTYPE, XLB, XUB, OBJ, XSOL, DSOL)

COUPV = -OBJ

ALPHA(1:NVAR,IULOC_L_QUICK(UU),id2) = XSOL
MUC(1:M,IULOC_L_QUICK(UU),id2) = DSOL

PROBLOTT(IULOC_L_QUICK(UU),id2) = MAXVAL(ALPHA(1:NVAR,IULOC_L_QUICK(UU),id2))

endsubroutine CONVEXIFY