module GLOBALS

use PARAM

implicit none
save

real(long) , dimension (ngp_u) :: Upoint             
real(long), dimension (CHEBORD+1, ngp_U) :: TVALUE   
real(long), dimension(CHEBORD+1) :: CHEBPARF,CHEBPARS   
real(long), dimension(CHEBORD+1) :: CHEBPARF_old,CHEBPARS_old   
real(long) , dimension (ngp_U) :: Ugrid						
real(long) , dimension (ngp_Ugraph) :: Ugridgraph			
real(long) , dimension (0:max_d) :: dgridgraph			
integer, dimension (0:max_d) :: d
real(long) , dimension (0:max_d) :: pi_h, pi_l
real(long) :: WWh, netwage, WW_US, VW_US, US_taxrate
real(long)  :: AP, mon_cost_curvature					
real(long) :: UVAL											
integer :: iU,id											
integer :: iter
real(long)  :: dist_plan, dist_plan_WWM, dist_plan_SA, dist_plan_MON, dist_plan_VB
real(long) , dimension(ngp_U) :: WWM,WWM_old, WWM_U, US_WW, UF_WW
real(long) , dimension(ngp_U) :: wwm_FIRST, wwm_second, wwm_third, wwm_third_smoothed, wwm_second_smoothed, wwm_first_smoothed, wwm_smoothed
real(long) , dimension (ngp_U,0:max_d) :: VM_SA,VM_MON, UPVM, COUPVM, COUPVM_old, VM_HN, VM_FIRST_BEST, VM_MON_TEMP 
real(long) , dimension (ngp_U,0:max_d) :: VM_SA_old, VM_MON_old, V_MON_BEFORE, V_MON_AFTER, effort_optimal, effort_optimal_HN, effort_optimal_FB, effort_optimal_emp, effort_optimal_HN_emp, effort_optimal_FB_emp, effort_emp
real(long) , dimension (ngp_U,0:max_d) :: COUPVM_U, c_MON, U_E, U_NO_MON, c_SA, US_SA, UF_SA, U_GOOD, U_BAD, MON_FREQ, RELEVANT_element, c_HN, U_S, U_F, c_FIRST_BEST, c_MON_WW, c_HN_WW, c_WW, opt_theta_h, c_FB_WW, U_FB_S, c_FB
real(long) , dimension (ngp_U,0:max_d) :: c_FB_analytic, VM_FIRST_BEST_analytic, U_FB_S_analytic, U_FB_F_analytic, effort_optimal_analytic
real(long) , dimension (ngp_U,0:max_d/2) :: VM_SA1, VM_MON1, UPVM1, COUPVM1
real(long) , dimension (ngp_U/2,0:max_d) :: VM_MON2, UPVM2, COUPVM2
real(long) , dimension (ngp_U,0:max_instrument_index,0:max_d) :: U_NM_instrument_guess, U_G_instrument_guess, U_B_instrument_guess
real(long) , dimension (ngp_U,0:max_d) :: consumption_sanction_level, consumption_high, consumption_low, consumption_sanction_percentage
real(long) , dimension (ngp_U,0:max_d) :: current_c_following_e, current_c_following_g, current_c_following_n, current_c_following_b
real(long) , dimension (ngp_U) :: min_MU_array, max_MU_array
real(long) , dimension (ngp_U,0:max_instrument_index) :: c_by_instrument, VM_MON_by_instrument
real(long) , dimension(0:num_instrument_cases_to_check +extra_grid_points) :: instrument_grid
real(long) , dimension(ngp_U, num_instrument_cases_to_check) :: U_E_U_theta, U_G_U_theta, U_B_U_theta, effort_U_theta, c_U_theta, V_U_theta
real(long) , dimension (ngp_U,0:max_d,effort_grid_size) :: VM_HN_effort
real(long), dimension(effort_grid_size) ::effort_grid, lifetime_discounted_effort, lifetime_discounted_effort_e
real(long), dimension(effort_grid_size_emp) ::effort_grid_emp
real(long), dimension(precision_grid_size) ::precision_grid
integer :: PC_run, quick_solvers, round_id
integer :: first_iter_in_main_loop
integer , dimension (ngp_U) :: ICM_MON
real(long) , dimension (ngp_Ugraph, 0:max_d) :: VG_SA, VG_MON
real(long) , dimension (ngp_Ugraph, 0:max_d) :: VGH_MON,UPVGH
real(long) , dimension (ngp_U) :: UMF_MON, UMF_FT, UMS_MON, UMS_FT, UM_hp
real(long), dimension(ngp_Ugraph) :: CCG_SA
real(long) , dimension (ngp_U,0:max_d) :: CCM_MON, CCM_FT
real(long) , dimension (ngp_Ugraph) :: CCG_MON, CCG_FT,TAXG
integer , dimension (ngp_Ugraph,0:max_d) :: PROGG 
real(long), dimension(ngp_U,ngp_U,0:max_d) :: ALPHA
real(long), dimension(2,ngp_U,0:max_d) :: MUC
real(long) :: UUC
real(long), dimension(ngp_U,0:max_d) :: PROBLOTT
real(long), dimension (SIM,TT) :: C_sim, U_sim, h_sim, tax_sim,UF_sim,US_sim, W_sim,wage_sim,netwage_sim, expwage_sim,ustax_sim
integer, dimension (SIM,TT) :: prog_sim, outcome_sim
integer, dimension (TT) :: count_0, count_1, count_2, count_3, count_4
integer, dimension (0:4,TT) :: state_counter
integer, dimension (0:20,TT) :: duration_counter
integer, dimension (1:4,TT) :: HC_counter
integer, dimension (0:4,TT) :: state_counter_OPT
integer, dimension (0:20,TT) ::duration_counter_OPT
integer, dimension (1:4,TT) :: HC_counter_OPT
integer, dimension (0:1,TT) :: emp_counter_OPT
real(long) :: c_MON_SIM, U_E_SIM, U_NO_MON_SIM, c_SA_SIM, US_SA_SIM, UF_SA_SIM
real(long) :: c_WW_SIM, US_WW_SIM, UF_WW_SIM
real(long) :: SA_SIM, MON_SIM, WW_SIM
integer :: LFAIND
real(long) :: LFA_UZERO_US, LFA_GAIN_US, LFA_CONSEQVAR, HCD_UZERO_US,LFA_BUDGETSAVE, &
                              HCD_GAIN_US, HCD_CONSEQVAR, LFA_UZERO_OPT,HCD_UZERO_OPT,HCD_BUDGETSAVE,LFA_GOVTEXP
real(long), dimension (20) :: Parameters
integer:: func_iteration, t_h_index, t_l_index
real(long) :: t_index_real, planner_savings
integer :: instrument_index
real(long) :: instrument_index_real, FOC_MON, MU, VM_MON_VALUE
real(long), dimension (ngp_U,0:100) :: VM_MON_MU, FOC_MON_MU
real(long), dimension (0:10,0:10) :: Stat_G, Stat_G1, Stat_G20, Stat_B, Stat_B1, Stat_B20 , Stat_dist
real(long) :: US,        U_G,           U_B,            U_NM, c
integer :: FLAG_READ, HnN
character (7) :: experiment
real(long) :: VM_FIRST_BEST_VALUE
real(long) :: kapa_MON
real(long) :: theta_h
real(long) :: theta_l,  send_value, send_utility
real(long):: U_0_MON, U_0_HN, consumption_increase, percent_savings
real(long):: opt_act_savings, opt_act_consumption_increase, opt_act_percent_consumption_increase, average_consumption, MON_UI_savings, MON_UI_consumption_increase, MON_UI_percent_consumption_increase
real(long):: target_average_utility, average_opt_cost, average_act_cost, average_first_best_cost, average_opt_UI_cost
real(long) :: initial_PU
integer, dimension (0:c_simulation_time) :: artificial_state
real(long), dimension (0:simulation_time) ::PU, agent_state, unemployment_draw
real(long), dimension (1:variance_simulation_time+1) ::variance_PU
integer, dimension (0:variance_simulation_time) ::variance_agent_state
real(long), dimension (variance_simulation_time) :: variance_consumption
real(long), dimension (simulation_time) :: consumption
real(long), dimension (simulation_time) :: tailored_consumption
real(long), dimension (1:simulation_agents,1:simulation_time) ::employment_draw, monitor_result, monitor_choice
real(long), dimension (1:variance_simulation_agents ,1:variance_simulation_time) ::variance_employment_draw, variance_monitor_result, variance_monitor_choice, variance_unemployment_draw
real(long), dimension (1:simulation_agents) ::agent_SIM_COST, agent_utility
real(long), dimension (simulation_agents ,simulation_time) ::cons_data, cons_data_HN, cons_data_SIM, cons_data_SIM_UI
real(long), dimension (variance_simulation_agents ,variance_simulation_time) ::variance_cons_data, variance_cons_data_SIM, variance_cons_data_SIM_UI
real(long), dimension (22) :: output
integer     :: flag_exists_MU_in_range, flag_shut_down_convexification, experiment_number, flag_CRRA
real(long)  :: instrument_local
real(long)  :: real_num_instrument_cases_to_check, initial_utility_in_actual_program
real(long) :: e, effort 
real(long) :: sigma, precision
integer :: instrument_type 
integer :: MAXFIN, counter, U_index
integer :: i_effort, variance_index, simulate_at_balanced_budget, write_simulation_data, fixed_effort
real(long), dimension(4,effort_grid_size,ngp_U) :: algorithm_value
real(long), dimension(ngp_U) :: stdev_c_HN, stdev_c_MON, stdev_c_FB, mean_c_HN, mean_c_MON, mean_c_FB

endmodule GLOBALS

