subroutine JAC (N, X, FJAC, LDFJAC)

use PARAM
use GLOBALS
use UTILS
integer    N, LDFJAC
real       X1(N), FJAC(LDFJAC,N)
real       COS, exp
INTRINSIC  COS, exp
real(long) :: US1,VAL_WW_U,VAL_COUPVM_U_G,VAL_COUPVM_U_B, U_G1, U_B1, consumption_argument
real(LONG) :: obj0, obj1,obj2,  coeff_1_g, coeff_1_b, coeff_2_g, coeff_2_b, obj3, obj4
real(LONG), dimension(2,0:2) :: V

do G_B_delta_index=0,2 
    if  (G_B_delta_index==0) then
        U_G1 = X1(1)
        U_B1 = X1(2)
    elseif  (G_B_delta_index==0) then
        U_G1 = X1(1) + delta_parameter
        U_B1 = X1(2)
    else
        U_G1 = X1(1)
        U_B1 = X1(2) + delta_parameter
    endif
    US1 = 1/(bita*pi_a_prime(effort))-(1-pi_a(effort))*theta_a_prime(effort,precision)*(U_G1-U_B1)/pi_a_prime(effort)+theta_a(effort,precision)*U_G1+(1-theta_a(effort,precision))*U_B1
    consumption_argument=UVAL+effort-bita*(pi_a(effort)*US1+(1-pi_a(effort))*((theta_a(effort,precision)*U_G1+(1-theta_a(effort,precision))*U_B1)))
    call SUBVAL_WW_U(US1,VAL_WW_U)
    call SUBVAL_COUPVM_U(U_G1 ,id+1,VAL_COUPVM_U_G)
    call SUBVAL_COUPVM_U(U_B1 ,id+1,VAL_COUPVM_U_B)
    obj0      = UINV_PRIME(consumption_argument)
    obj1      = pi_a(effort)*(1-pi_a(effort))*theta_a_prime(effort,precision)/pi_a_prime(effort)
    coeff_1_g = theta_a(effort,precision)-obj1
    coeff_1_b = 1-theta_a(effort,precision)+obj1
    obj2      = (1-pi_a(effort))*theta_a_prime(effort,precision)/pi_a_prime(effort)
    coeff_2_g = pi_a(effort)*(theta_a(effort,precision)-obj2)
    coeff_2_b = pi_a(effort)*(1-theta_a(effort,precision)+obj2)
    coeff_3_g = theta_a(effort,precision)*(1-pi_a(effort))
    coeff_3_b = (1-theta_a(effort,precision))*(1-pi_a(effort))
    obj3 = pi_a(effort)
    obj4 = theta_a(effort,precision)
    if  (G_B_delta_index==0) then
        V(1,0) = obj0*coeff_1_g + coeff_2_g*VAL_WW_U + coeff_3_g*VAL_COUPVM_U_G
        V(2,0) = obj0*coeff_1_b + coeff_2_b*VAL_WW_U + coeff_3_b*VAL_COUPVM_U_B
    elseif  (G_B_delta_index==1) then
        V(1,1) = obj0*coeff_1_g + coeff_2_g*VAL_WW_U + coeff_3_g*VAL_COUPVM_U_G
        V(2,1) = obj0*coeff_1_b + coeff_2_b*VAL_WW_U + coeff_3_b*VAL_COUPVM_U_B
    else
        V(1,2) = obj0*coeff_1_g + coeff_2_g*VAL_WW_U + coeff_3_g*VAL_COUPVM_U_G
        V(2,2) = obj0*coeff_1_b + coeff_2_b*VAL_WW_U + coeff_3_b*VAL_COUPVM_U_B
    endif
enddo
FJAC(1,1) = (V(1,1)-V(1,0))/delta_parameter
FJAC(1,2) = (V(1,2)-V(1,0))/delta_parameter
FJAC(2,1) = (V(2,1)-V(2,0))/delta_parameter
FJAC(2,2) = (V(2,2)-V(2,0))/delta_parameter
return

endsubroutine JAC 