subroutine PROG_MON_NEW

use PARAM
use GLOBALS
use UTILS
use NUMERICAL_LIBRARIES
use UMACH_INT
implicit none

external  FUNCTION_MON_DNEQBF, FUNCTION_MON_DNEQNF, FUNCTION_MON_DNEQNJ, LSJAC, JAC
real(long) :: VAL_WW,   VAL_COUPVM_G,   VAL_COUPVM_B,   VAL_COUPVM_NM
real(long) :: VAL_WW_U, VAL_COUPVM_U_G, VAL_COUPVM_U_B, VAL_COUPVM_U_NM
real(long) :: consumption_argument, FNORM 
real(long) ::  sum_U_G_UVAL_gap,  sum_U_B_UVAL_gap,  sum_U_NM_UVAL_gap
real(long) :: mean_U_G_UVAL_gap, mean_U_B_UVAL_gap, mean_U_NM_UVAL_gap
integer :: sum_index_U_G_UVAL_gap, sum_index_U_B_UVAL_gap, sum_index_U_NM_UVAL_gap, iU_index
integer, parameter :: N=number_of_variables_NEW
integer :: index_1, index_2, algorithn_index, chosen_solver
real(long), dimension(number_of_variables_NEW) :: FSCALE, FVECT, X, XGUESS, XSCALE, EST_V_MON_FOC
integer, dimension(6) :: IPARAM
real(long), dimension(5) :: RPARAM
real(long), dimension(18) :: DEBUG
real(long), dimension(N) :: FVEC
integer    N1 
parameter  (N1=3)
integer    K, NOUT
real(long) X1(N1), XGUESS1(N1) 

XGUESS1(1) =4.0
XGUESS1(2) =4.0
XGUESS1(3) =4.0      
chosen_solver=2
XSCALE(1)=0.01
XSCALE(2)=0.01
FSCALE(1)=0.00001
FSCALE(2)=0.00001
IPARAM(2)=40
IPARAM(3)=1000000
IPARAM(4)=1000000
IPARAM(5)=1000000
IPARAM(6)=1
RPARAM(1)=0
RPARAM(2)=0.000000001
RPARAM(3)=0.000000001
RPARAM(5)=0.001
call ERSET (1,0,-1)
call ERSET (2,0,-1)
call ERSET (3,0,-1)
call ERSET (4,0,0)
call ERSET (5,0,0)
XGUESS(1)=UVAL +1.0
XGUESS(2)=UVAL -1.0
do algorithn_index=chosen_solver,chosen_solver
    if (algorithn_index==1)  then
        call DNEQBF (FUNCTION_MON_DNEQBF, N, XGUESS, XSCALE, FSCALE, IPARAM, RPARAM, X, FVECT)
    elseif (algorithn_index==2 )  then
        call DNEQNF (FUNCTION_MON_DNEQNF, ERRREL, N, ITMAX, XGUESS, X, FNORM)
    elseif (algorithn_index==3)  then
        call DNEQNJ (FUNCTION_MON_DNEQNJ, LSJAC, ERRREL, N, ITMAX, XGUESS, X, FNORM)
    elseif (algorithn_index==4)  then
        call DNEQBJ (FUNCTION_MON_DNEQBF, JAC, N, XGUESS, XSCALE, FSCALE, IPARAM, RPARAM, X, FVEC)
    endif
    U_G = X(1)
    U_B = X(2)
    US = 1/(bita*pi_a_prime(effort))-(1-pi_a(effort))*theta_a_prime(effort,precision)*(U_G-U_B)/pi_a_prime(effort)+theta_a(effort,precision)*U_G+(1-theta_a(effort,precision))*U_B
    consumption_argument=UVAL+effort-bita*(pi_a(effort)*US+(1-pi_a(effort))*((theta_a(effort,precision)*U_G+(1-theta_a(effort,precision))*U_B)))
    call SUBVAL_WW(US,VAL_WW)
    call SUBVAL_COUPVM(U_G ,id+1,VAL_COUPVM_G)
    call SUBVAL_COUPVM(U_B ,id+1,VAL_COUPVM_B)
    c=UINV(consumption_argument)
    if (flag_CRRA==1 .and. isnan(c)) then
        c=0.01
    endif
    if (instrument_type==1) then
        VM_MON_VALUE= -c  -(1.-pi_a(effort))*kapa_MON**mon_cost_curvature+ bita*(pi_a(effort)*VAL_WW+(1.-pi_a(effort))*(theta_a(effort,precision)*VAL_COUPVM_G+(1-theta_a(effort,precision)*VAL_COUPVM_B)))
    elseif (instrument_type==2) then
        VM_MON_VALUE= -c + bita*(pi_a(effort)*VAL_WW+(1.-pi_a(effort))*((theta_a(effort,precision)*VAL_COUPVM_G+(1-theta_a(effort,precision))*VAL_COUPVM_B))) -kapa_precision(precision) 
    else
        print *, 'instrument_type is not 1 or 2'
        stop
    endif
    algorithm_value(algorithn_index,i_effort,iu)=VM_MON_VALUE
enddo
VM_MON_VALUE=(algorithm_value(chosen_solver,i_effort,iu))

endsubroutine PROG_MON_NEW