subroutine SUBVAL_COUPVM_U(UU,id1,VAL_COUPVM_U)

use PARAM
use GLOBALS
use ULOC

implicit none
real(long),intent(in) :: UU
integer, intent (in) :: id1
real(long)  :: VAL_COUPVM_U, a1,a2
integer :: iU_L, iU_H, id2
real(long) :: U_L, U_H

if (id1<=max_d) then
	id2=id1
else
	id2=id1-1
endif
iU_L = IULOC_L_QUICK(UU)
iU_H = IULOC_H_QUICK(UU)
U_L = Ugrid(iU_L)
U_H = Ugrid(iU_H)
if (iU_H == iU_L + 1)  then 
	VAL_COUPVM_U = COUPVM_U(iU_L,id2) + (COUPVM_U(iU_H,id2) - COUPVM_U(iU_L,id2)) / (U_H - U_L) * (UU - U_L)
elseif (iU_L==1 .AND. iU_H==1) then 
	if (IU>=UMIN) then
			VAL_COUPVM_U = COUPVM_U(1,id2)  + (COUPVM_U(2,id2) - COUPVM_U(1,id2))  * (UU - Ugrid(1)) / (Ugrid(2) - Ugrid(1))
	else
		if (COUPVM_U(3,id2) - COUPVM_U(2,id2) /=0 .and. iter>iter_for_subtle_sub_val) then
			VAL_COUPVM_U = COUPVM_U(1,id2)  + (UU - Ugrid(1))*(COUPVM_U(2,id2) - COUPVM_U(1,id2))   / (Ugrid(2) - Ugrid(1))*(COUPVM_U(2,id2) - COUPVM_U(1,id2))   / (Ugrid(2) - Ugrid(1))/(COUPVM_U(3,id2) - COUPVM_U(2,id2))   * (Ugrid(3) - Ugrid(2))
		else
			VAL_COUPVM_U = COUPVM_U(1,id2)  + (UU - Ugrid(1))*(COUPVM_U(2,id2) - COUPVM_U(1,id2))   / (Ugrid(2) - Ugrid(1))
		endif
	endif
elseif (iU_L==ngp_U .AND. iU_H==ngp_U) then 
	if (COUPVM_U(ngp_U-1,id2) - COUPVM_U(ngp_U-2,id2) /= 0 .and. iter>iter_for_subtle_sub_val) then
		VAL_COUPVM_U = COUPVM_U(ngp_U,id2)  + (UU - Ugrid(ngp_U))*(COUPVM_U(ngp_U,id2) - COUPVM_U(ngp_U-1,id2))   / (Ugrid(ngp_U) - Ugrid(ngp_U-1))*(COUPVM_U(ngp_U,id2) - COUPVM_U(ngp_U-1,id2))   / (Ugrid(ngp_U) - Ugrid(ngp_U-1))/(COUPVM_U(ngp_U-1,id2) - COUPVM_U(ngp_U-2,id2))   * (Ugrid(ngp_U-1) - Ugrid(ngp_U-2))
	else
		VAL_COUPVM_U = COUPVM_U(ngp_U,id2)  + (UU - Ugrid(ngp_U))*(COUPVM_U(ngp_U,id2) - COUPVM_U(ngp_U-1,id2))   / (Ugrid(ngp_U) - Ugrid(ngp_U-1))
	endif
else
	VAL_COUPVM_U = COUPVM_U(iU_L,id2)
endif
a1=COUPVM_U(iU_L,id2)
a2=COUPVM_U(iU_H,id2)

endsubroutine SUBVAL_COUPVM_U