subroutine SUBVAL_WW(UU,VAL_WW)

use PARAM
use GLOBALS
use ULOC

implicit none
real(long),intent(in) :: UU
real(long)  :: VAL_WW
integer :: iU_L, iU_H
real(long) :: U_L, U_H, a1,a2

iU_L = IULOC_L_QUICK(UU)
iU_H = IULOC_H_QUICK(UU)
U_L = Ugrid(iU_L)
U_H = Ugrid(iU_H)
if (UU>Umax) then
	if (WWM(ngp_U-1) - WWM(ngp_U-2) /= 0 .and. iter>iter_for_subtle_sub_val) then
		VAL_WW = WWM(ngp_U) + (UU-Umax) / (Ugrid(ngp_U)-Ugrid(ngp_U-1))* (WWM(ngp_U) - WWM(ngp_U-1))/ (Ugrid(ngp_U)-Ugrid(ngp_U-1))* (WWM(ngp_U) - WWM(ngp_U-1))* (Ugrid(ngp_U-1)-Ugrid(ngp_U-2))/ (WWM(ngp_U-1) - WWM(ngp_U-2))
	else
		VAL_WW = WWM(ngp_U) + (UU-Umax) / (Ugrid(ngp_U)-Ugrid(ngp_U-1))* (WWM(ngp_U) - WWM(ngp_U-1))
	endif
elseif (UU<Umin) then
	if (WWM(3) - WWM(2) /=0 .and. iter>iter_for_subtle_sub_val) then
		VAL_WW = WWM(1) - (Umin-UU) / (Ugrid(2)-Ugrid(1))* (WWM(2) - WWM(1))/ (Ugrid(2)-Ugrid(1))* (WWM(2) - WWM(1))* (Ugrid(3)-Ugrid(2))/ (WWM(3) - WWM(2))
	else
		VAL_WW = WWM(1) - (Umin-UU) / (Ugrid(2)-Ugrid(1))* (WWM(2) - WWM(1))
	endif
elseif (iU_H == iU_L)  then
	VAL_WW = WWM(iU_L) 
else
	VAL_WW = WWM(iU_L) + (WWM(iU_H) - WWM (iU_L)) / (U_H - U_L)  & 
	                  * (UU - U_L)
endif
a1=WWM(iU_L)
a2=WWM(iU_H)

endsubroutine SUBVAL_WW


