subroutine SUBVAL_WW_U(UU,VAL_WW_U)

use PARAM
use GLOBALS
use ULOC

implicit none
real(long),intent(in) :: UU
real(long)  :: VAL_WW_U
integer :: iU_L, iU_H
real(long) :: U_L, U_H, a1, a2

iU_L = IULOC_L_QUICK(UU)
iU_H = IULOC_H_QUICK(UU)
U_L = Ugrid(iU_L)
U_H = Ugrid(iU_H)
if (UU>Umax) then
	if (WWM_U(ngp_U-1) - WWM_U(ngp_U-2) /= 0 .and. iter>iter_for_subtle_sub_val) then
		VAL_WW_U = WWM_U(ngp_U) + (UU-Umax) / (Ugrid(ngp_U)-Ugrid(ngp_U-1))* (WWM_U(ngp_U) - WWM_U(ngp_U-1))/ (Ugrid(ngp_U)-Ugrid(ngp_U-1))* (WWM_U(ngp_U) - WWM_U(ngp_U-1))* (Ugrid(ngp_U-1)-Ugrid(ngp_U-2))/ (WWM_U(ngp_U-1) - WWM_U(ngp_U-2))
	else
		VAL_WW_U = WWM_U(ngp_U) + (UU-Umax) / (Ugrid(ngp_U)-Ugrid(ngp_U-1))* (WWM_U(ngp_U) - WWM_U(ngp_U-1))
	endif
elseif (UU<Umin) then
	if (WWM_U(3) - WWM_U(2) /= 0 .and. iter>iter_for_subtle_sub_val) then
		VAL_WW_U = WWM_U(1) - (Umin-UU) / (Ugrid(2)-Ugrid(1))* (WWM_U(2) - WWM_U(1))/ (Ugrid(2)-Ugrid(1))* (WWM_U(2) - WWM_U(1))* (Ugrid(3)-Ugrid(2))/ (WWM_U(3) - WWM_U(2))
	else
		VAL_WW_U = WWM_U(1) - (Umin-UU) / (Ugrid(2)-Ugrid(1))* (WWM_U(2) - WWM_U(1))
	endif
elseif (iU_H == iU_L)  then
	VAL_WW_U = WWM_U(iU_L)
else
	VAL_WW_U = WWM_U(iU_L) + (WWM_U(iU_H) - WWM_U(iU_L)) / (U_H - U_L)  & 
                  * (UU - U_L)
endif
a1=WWM_U(iU_L)
a2=WWM_U(iU_H)

endsubroutine SUBVAL_WW_U