subroutine TAILORED_CONSUMPTION_SIMULATION

use PARAM
use GLOBALS

implicit none
integer :: time, agent
real (long) :: local_value, local_MON_FREQ

PU(1)=-580 
agent_state(1)=0 
do agent=1,3
    agent_state=2
    if (agent==1) then
	    agent_state(1)=3
	    agent_state(2)=3
	    agent_state(3)=3	
	    agent_state(4)=3	
    elseif (agent==2) then	
	    agent_state(1)=4
	    agent_state(2)=4
	    agent_state(3)=4
	    agent_state(4)=4
    	
    elseif (agent==3) then
	    agent_state(1)=4
	    agent_state(2)=3
	    agent_state(3)=3	
	    agent_state(4)=3
    endif	
	do time=1,tailored_simulation_time-1
		if (time>4) then		
			agent_state(time)=1
		endif
		RELEVANT_element=c_MON
		send_value=PU(time)
		call interpolate_PU(send_value,local_value)
		consumption(time)=local_value
		if (agent_state(time-1)==1) then 			
			PU(time+1)=PU(time)			
		else 		
			if (agent_state(time)==1) then				
				RELEVANT_element=U_E
				send_value=PU(time)
				call interpolate_PU(send_value,local_value)
				PU(time+1)=local_value
			elseif (agent_state(time)==2) then 							
				RELEVANT_element=U_NO_MON	
				send_value=PU(time)
				call interpolate_PU(send_value,local_value)
				PU(time+1)=local_value				 
			elseif (agent_state(time)==3) then 										
				RELEVANT_element=U_GOOD
				send_value=PU(time)
				call interpolate_PU(send_value,local_value)
				PU(time+1)=local_value
			elseif (agent_state(time)==4) then  									
				RELEVANT_element=U_BAD
				send_value=PU(time)
				call interpolate_PU(send_value,local_value)
				PU(time+1)=local_value
			else
				print *, 'MISSING AGENT STATE'
			endif 
		endif 
	enddo 
	if (agent_state(time)>1) then
		RELEVANT_element=c_MON
		send_value=PU(time)
		call interpolate_PU(send_value,local_value)
		consumption(time)=local_value
	elseif (agent_state(time)==1) then
		RELEVANT_element=c_MON_WW
		send_value=PU(time)
		call interpolate_PU(send_value,local_value)
		consumption(time)=local_value		
	endif	
	if (PC_run == 1) then	
	    if (agent==1) then
	        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\tailored_simulated_consumption1.txt", position="rewind")
	        write (9, *) consumption; close (UNIT=9)
	    elseif (agent==2) then
	        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\tailored_simulated_consumption2.txt", position="rewind")
	        write (9, *) consumption; close (UNIT=9)
	    elseif (agent==3) then
	        open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\tailored_simulated_consumption3.txt", position="rewind")
	        write (9, *) consumption; close (UNIT=9)
	    endif	
	else	
	    if (agent==1) then
	        open(unit=1, file="tailored_simulated_consumption1.txt")
	        write (1, *) consumption; close (UNIT=1)
	    elseif (agent==2) then
	        open(unit=1, file="tailored_simulated_consumption2.txt")
	        write (1, *) consumption; close (UNIT=1)
	    elseif (agent==3) then
	        open(unit=1, file="tailored_simulated_consumption3.txt")
	        write (1, *) consumption; close (UNIT=1)
	    endif	
	endif
enddo

endsubroutine TAILORED_CONSUMPTION_SIMULATION